import 'dart:async';

import 'package:flutter/services.dart';
import 'package:flutter/material.dart';
import 'package:flutter/cupertino.dart';

typedef List<Widget> CreateWidgetList();

class WMHPickerView extends Dialog {
  List<Map> pickerData;
  List<String> selectedArr = [];
  final callBack;
  bool showPicker;
  Color cancelBtnColor;
  Color confirmBtnColor;
  Color pickerBackgroundColor;
  Color pickerTextColor;
  double textSize;
  double pickerHeight;

  WMHPickerView({Key key,
    this.pickerData,
    this.callBack,
    this.showPicker,
    this.cancelBtnColor,
    this.confirmBtnColor,
    this.pickerBackgroundColor,
    this.pickerTextColor,
    this.textSize,
    this.pickerHeight,
  }) : super(key : key);

  @override
  Widget build(BuildContext context) {
    // TODO: implement build
    return GestureDetector(
      onTap: () {
        Navigator.pop(context);
      },
      child: Material(
        type: MaterialType.transparency,
        child: Container(
          width: MediaQuery.of(context).size.width,
          height: MediaQuery.of(context).size.height,
          alignment: Alignment.bottomCenter,
          child: Container(
            width: MediaQuery.of(context).size.width,
            height: this.pickerHeight,
            color: this.pickerBackgroundColor,
            child: Container(
              child: Column(
                children: <Widget>[
                  _buttonVIew(context),
                  Row(
                    children: _getColumnPicker(context),
                  ),
                ],
              ),
            ),
          ),
        ),
      ),
    );
  }

  _getColumnPicker(BuildContext context) {
    List<Widget> pickerColumnArr = [];
    for (var i = 0; i < this.pickerData.length; i++) {
      Map model = this.pickerData[i];
      if (selectedArr.length == this.pickerData.length) {
        selectedArr = [];
      }
      selectedArr.add(model['subDatas'][0].toString());
      pickerColumnArr.add(
        _buildBottomPicker(
          CupertinoPicker(
            scrollController: new FixedExtentScrollController(initialItem: 0),
            itemExtent: 40.0,
            backgroundColor: this.pickerBackgroundColor,
            onSelectedItemChanged: (int index) {
              selectedArr[i] = model['subDatas'][index].toString();
              print(selectedArr.toString());
            },
            children: List<Widget>.generate(model['subDatas'].length, (int index) {
              return Center(
                child: Text(model['subDatas'][index].toString()),
              );
            }),
          ),context
        ),
      );
    }
    return pickerColumnArr;
  }

  Widget _buttonVIew(BuildContext context) {
    return new Container(
      width: MediaQuery.of(context).size.width,
      height: 50.0,
      color: this.pickerBackgroundColor,
      child: new Row(
        children: <Widget>[
          Container(
            child: FlatButton(
              onPressed: () {
                print('点击取消');
                Navigator.pop(context);
              },
              child: new Text(
                '取消',
              ),
            ),
          ),
          Container (
            child: FlatButton(
              onPressed: () {
                print('点击完成');
                Navigator.pop(context);
                callBack(this.selectedArr);
              },
              child: new Text(
                '完成',
              ),
            ),
          ),
        ],
        mainAxisSize: MainAxisSize.max,
        mainAxisAlignment: MainAxisAlignment.spaceBetween,
      ),
    );
  }

  Widget _buildBottomPicker(Widget picker, BuildContext context) {
    return Container(
      height: this.pickerHeight - 70.0,
      width: MediaQuery.of(context).size.width / this.pickerData.length,
      color: this.pickerBackgroundColor,
      child: DefaultTextStyle(
        style: TextStyle(
          color: this.pickerTextColor,
          fontSize: this.textSize,
        ),
        child: GestureDetector(
          key: Key('picker'),
          onTap: (){},
          child: SafeArea(
            top: false,
            child: picker,
          ),
        ),
      ),
    );
  }
}

class Wmhpicker {
  static const MethodChannel _channel =
      const MethodChannel('wmhpicker');

  static Future<String> get platformVersion async {
    final String version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }
}
